OpenTTD: NWidgetScrollbar Class Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Static Private Attributes
NWidgetScrollbar Class Reference
Hierarchical widgets

Nested widget to display and control a scrollbar in a window. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetScrollbar:

## Public Member Functions
| NWidgetScrollbar (WidgetType tp, Colours colour, int index)
| Scrollbar widget.
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | Draw (const Window *w)
| Draw the widgets of the tree.
Public Member Functions inherited from NWidgetCore
| NWidgetCore (WidgetType tp, Colours colour, uint fill_x, uint fill_y, uint32 widget_data, StringID tool_tip)
| Initialization of a 'real' widget.
void | SetIndex (int index)
| Set index of the nested widget in the widget array.
void | SetDataTip (uint32 widget_data, StringID tool_tip)
| Set data and tool tip of the nested widget.
void | SetLowered (bool lowered)
| Lower or raise the widget.
bool | IsLowered () const
| Return whether the widget is lowered.
void | SetDisabled (bool disabled)
| Disable (grey-out) or enable the widget.
bool | IsDisabled () const
| Return whether the widget is disabled.
void | FillNestedArray (NWidgetBase **array, uint length)
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
bool | IsHighlighted () const
| Return whether the widget is highlighted.
TextColour | GetHighlightColour () const
| Return the colour of the highlight.
void | SetHighlighted (TextColour highlight_colour)
| Highlight the widget or not.
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets.
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget.
void | SetMinimalTextLines (uint8 min_lines, uint8 spacing, FontSize size)
| Set minimal text lines for the widget.
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size.
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.
Public Member Functions inherited from Scrollbar
| Scrollbar (bool is_vertical)
uint16 | GetCount () const
| Gets the number of elements in the list.
uint16 | GetCapacity () const
| Gets the number of visible elements of the scrollbar.
uint16 | GetPosition () const
| Gets the position of the first visible element in the list.
bool | IsVisible (uint16 item) const
| Checks whether given current item is visible in the list.
bool | IsVertical () const
| Is the scrollbar vertical or not?
void | SetStepSize (uint16 stepsize)
| Set the distance to scroll when using the buttons or the wheel.
void | SetCount (int num)
| Sets the number of elements in the list.
void | SetCapacity (int capacity)
| Set the capacity of visible elements.
void | SetCapacityFromWidget (Window *w, int widget, int padding=0)
| Set capacity of visible elements from the size and resize properties of a widget.
void | SetPosition (int position)
| Sets the position of the first visible element.
void | UpdatePosition (int difference, ScrollbarStepping unit=SS_SMALL)
| Updates the position of the first visible element by the given amount.
void | ScrollTowards (int position)
| Scroll towards the given position; if the item is visible nothing happens, otherwise it will be shown either at the bottom or top of the window depending on where in the list it was.
int | GetScrolledRowFromWidget (int clickpos, const Window *const w, int widget, int padding=0, int line_height=-1) const
| Compute the row of a scrolled widget that a user clicked in.

## Static Public Member Functions
static void | InvalidateDimensionCache ()
static Dimension | GetVerticalDimension ()
static Dimension | GetHorizontalDimension ()

## Static Private Attributes
static Dimension | vertical_dimension = {0, 0}
| Cached size of vertical scrollbar button.
static Dimension | horizontal_dimension = {0, 0}
| Cached size of horizontal scrollbar button.

## Additional Inherited Members
Public Types inherited from Scrollbar
enum | ScrollbarStepping { SS_RAW, SS_SMALL, SS_BIG }
| Stepping sizes when scrolling. More...
Data Fields inherited from NWidgetCore
NWidgetDisplay | disp_flags
| Flags that affect display and interaction with the widget.
Colours | colour
| Colour of this widget.
int | index
| Index of the nested widget in the widget array of the window (`-1` means 'not used').
uint32 | widget_data
| Data of the widget.
StringID | tool_tip
| Tooltip of the widget.
int | scrollbar_index
| Index of an attached scrollbar.
TextColour | highlight_colour
| Colour of highlight.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Nested widget to display and control a scrollbar in a window.

Also assign the scrollbar to other widgets using SetScrollbar() to make the mousewheel work.

Definition at line 750 of file widget_type.h.

## Constructor & Destructor Documentation

NWidgetScrollbar::NWidgetScrollbar | ( | WidgetType | tp,
|  | Colours | colour,
|  | int | index
| ) |  |

Scrollbar widget.

Parameters

  tp | Scrollbar type. (horizontal/vertical)
  colour | Colour of the scrollbar.
  index | Index in the widget array used by the window system.

Definition at line 1988 of file widget.cpp.

References NWID_HSCROLLBAR, NWID_VSCROLLBAR, and NWidgetCore::SetIndex().

## Member Function Documentation

void NWidgetScrollbar::Draw | ( | const Window * | w | ) |
| virtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 2025 of file widget.cpp.

References _colour_gradient, NWidgetCore::colour, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::disp_flags, DrawHorizontalScrollbar(), DrawVerticalScrollbar(), FILLRECT_CHECKER, GfxFillRect(), HasBit(), NWidgetCore::IsDisabled(), ND_SCROLLBAR_BTN, NDB_SCROLLBAR_DOWN, NDB_SCROLLBAR_UP, NWID_HSCROLLBAR, NWidgetBase::pos_x, NWidgetBase::pos_y, Window::scrolling_scrollbar, and NWidgetBase::type.

void NWidgetScrollbar::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1994 of file widget.cpp.

References NWidgetCore::index, NWidgetResizeBase::min_x, NWidgetResizeBase::min_y, Window::nested_array, Window::nested_array_size, NWID_HSCROLLBAR, NWID_VSCROLLBAR, NWidgetCore::SetDataTip(), NWidgetResizeBase::SetFill(), NWidgetResizeBase::SetMinimalSize(), NWidgetResizeBase::SetResize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, and NWidgetBase::type.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp